                processor 6502
                include "vcs.h"
                include "macro.h"


ARENA_HEIGHT = 200

                SEG.U vars
                ORG $80
    ; DoDraw Graphic Pointers in $87-8a
Player0Ptr:         ds 2    ; used for drawing player0
Player1Ptr:         ds 2    ; used for drawing player1
Player0Draw:        ds 1    ; used for drawing player0
Player1Draw:        ds 1    ; used for drawing player1
SpriteXPosition ds 1
PlayerX         ds 2             ; x coordinate
ObjectY			ds 2
PS_temp			ds 1


  
                SEG code
                ORG $F800
Reset
   ; Clear RAM and all TIA registers

        CLEAN_START            
       ;------------------------------------------------
       ; Once-only initialisation...
                lda #$c8
                sta COLUPF             ; set the playfield colour


				lda #14
				sta COLUP1 ;color it [actually setting player 1 color, which missile 1 matches]
             
				lda #$20
				sta NUSIZ1	;make it quadwidth (not so thin, that)			 
				
				lda #$00
				sta NUSIZ0	;make it quadwidth (not so thin, that)					
		      
				lda #$28
				sta COLUP0 
		

		
				lda #20
                sta PlayerX
		
				lda #140
				sta PlayerX+1	

				lda #30
				sta ObjectY
				
				lda #38
				sta ObjectY+1
				


		
				;rts		
		
		
StartOfFrame:

        lda #2      ; LoaD Accumulator with 2
        sta WSYNC   ; STore Accumulator to WSYNC, any value halts CPU until start of next scanline
        sta VSYNC   ; Accumulator D1=1, turns on Vertical Sync signal
		lda #0
        sta VBLANK  ; Accumulator D1=1, turns on Vertical Blank signal (image output off)
        lda #20
        sta TIM64T  ; set timer for end of Vertical Blank
        sta WSYNC   ; 1st scanline of VSYNC
        sta WSYNC   ; 2nd scanline of VSYNC
        lda #0      ; LoaD Accumulator with 0
        sta GRP0
        sta GRP1
        sta WSYNC   ; 3rd scanline of VSYNC
        sta VSYNC   ; Accumulator D1=0, turns off Vertical Sync signal
     


				
				jsr VerticalBlank

				jsr Kernel

				jsr Draw_MrCelery

		
				;jsr Draw_Incinerator
				;jsr DrawPlayer1XPos
				jmp Overscan1	


VerticalBlank:    




		jsr DrawPlayer0XPos	
        jsr Joystick
        jsr PositionObjects

VBwait:
        sta WSYNC
        bit TIMINT
        bpl VBwait    ; wait for the timer to denote end of Vertical Blank
 
        rts

	
		
				;jsr Draw_Vegetarian				
				;jsr Draw_MrCelery
				




	
PositionObjects:

	
        ldx #1             ; position players 0 and 1
POloop2:
        lda PlayerX,x       ; get the object's X position
        jsr PosObject       ; set coarse X position and fine-tune amount 
        dex                 ; DEcrement X
        bpl POloop2          ; Branch PLus so we position all objects
        sta WSYNC           ; wait for end of scanline
        sta HMOVE           ; Tell TIA to use fine-tune values to set final X positions

             
    ; Player0Draw = ARENA_HEIGHT + HUMAN_HEIGHT - Y_position
        lda #(ARENA_HEIGHT + VEG_HEIGHT)
        sec
        sbc ObjectY
        sta Player0Draw
        
    ; Set Player0Ptr to proper value for drawing player0
        lda #<(VegGfx + VEG_HEIGHT - 1)
        sec
        sbc ObjectY
        sta Player0Ptr
        lda #>(VegGfx + VEG_HEIGHT - 1)
        sbc #0
        sta Player0Ptr+1
        
    ; Player1Draw = ARENA_HEIGHT + BOX_HEIGHT - Y_position
        lda #(ARENA_HEIGHT + INCIN_HEIGHT)
        sec
        sbc ObjectY+1
        sta Player1Draw        
        
    ; Set Player1Ptr to proper value for drawing player1
        lda #<(IncinGfx + INCIN_HEIGHT - 1)
        sec
        sbc ObjectY+1
        sta Player1Ptr
        lda #>(IncinGfx + INCIN_HEIGHT - 1)
        sbc #0
        sta Player1Ptr+1
        
        rts      
        
		
Kernel:    
        ;     
        lda #0 
        ldy #ARENA_HEIGHT   ;        init loop counter
        sta WSYNC
        ;sta VBLANK          ; 3  3 - turn on video output

 
ArenaLoop:                  ; - 11 - time of longest path here
        lda #VEG_HEIGHT-1 ; 2 13 - height of the human graphics, 
        dcp Player0Draw     ; 5 18 - Decrement Player0Draw and compare with height
        bcs DoDrawGrp0      ; 2 20 - (3 21) if Carry is Set then player0 is on current scanline
        lda #0              ; 2 22 - otherwise use 0 to turn off player0
        .byte $2C           ; 4 26 - $2C = BIT with absolute addressing, trick that
                            ;        causes the lda (Player0Ptr),y to be skipped
DoDrawGrp0:                 ;   21 - from bcs DoDrawGRP0
        lda (Player0Ptr),y  ; 5 26 - load the shape for player0
        tax                 ; 2 28 - save in X for update during Horizontal Blanking

        lda #INCIN_HEIGHT-1   ; 2 30 - height of the box graphics, subtract 1 due to starting with 0
        dcp Player1Draw     ; 5 35 - Decrement Player1Draw and compare with height
        bcs DoDrawGrp1      ; 2 37 - (3 38) if Carry is Set, then player1 is on current scanline
        lda #0              ; 2 39 - otherwise use 0 to turn off player1
        .byte $2C           ; 4 43 - $2C = BIT with absolute addressing, trick that
                            ;        causes the lda (Player1Ptr),y to be skipped
							
							

DoDrawGrp1:                 ;   38 - from bcs DoDrawGrp1
        lda (Player1Ptr),y  ; 5 43 - load the shape for player1
        
        sta WSYNC           ; 3 46/0 - halts CPU until start of next scanline
        stx GRP0            ; 3  3 - draw the human
        sta GRP1            ; 3  6 - draw the box
        dey                 ; 2  8 - update loop counter
        bne ArenaLoop       ; 2 10 - 3 11 if taken
        
		
		;jsr PositionSprites

        rts                 ; 6 16		
		
 
PosObject:
        sec
        sta WSYNC
DivideLoop
        sbc #15        ; 2  2 - each time thru this loop takes 5 cycles, which is 
        bcs DivideLoop ; 2  4 - the same amount of time it takes to draw 15 pixels
        eor #7         ; 2  6 - The EOR & ASL statements convert the remainder
        asl            ; 2  8 - of position/15 to the value needed to fine tune
        asl            ; 2 10 - the X position
        asl            ; 2 12
        asl            ; 2 14
        sta.wx HMP0,X  ; 5 19 - store fine tuning of X
        sta RESP0,X    ; 4 23 - set coarse X position of object
        rts            ; 6 29 - ReTurn from Subroutine

			






Overscan1:

   ; 30 scanlines of overscan...
                ldx #0

Overscan:     
				sta WSYNC

                inx
                cpx #21
                bne Overscan
				
			    lda #2
                sta VBLANK          ; end of screen - enter blanking	


                jmp StartOfFrame


Joystick:


        lda SWCHA       ; fetch state of both joysticks
	    asl 
	    asl
        asl                     ; shift A bits left, D is now in the carry bit
        bcs CheckUp             ; branch if joystick not held down
		
		
		
        ldy ObjectY+1             ; get the object's Y position
        dey                     ; move it down
        cpy #20               ; test for bottom of screen
        bne SaveY               ; save Y if we're not at the bottom
		ldy ObjectY+1
        jmp CheckUp
SaveY:  sty ObjectY+1           ; save Y



CheckUp:
        asl                     ; shift A bits left, U is now in the carry bit
        bcs DoneWithJoystick    ; branch if joystick not held up
        ldy ObjectY+1            ; get the object's Y position
        iny                     ; move it up
        cpy #60      ; test for top of screen
        bne SaveY2              ; save Y if we're not at the bottom
		ldy ObjectY+1
        jmp DoneWithJoystick
SaveY2:  sty ObjectY+1           ; save Y

DoneWithJoystick:
        rts
        




Divide15
.POS	SET 0
	REPEAT 256
	.byte (.POS / 15) + 1
.POS	SET .POS + 1
	REPEND


DrawPlayer0XPos:	
		;sta WSYNC
						
			; Now adjust the sprite position

		inc PlayerX
		ldx PlayerX
		cpx #150
		bcc GT0
		ldx #2
		stx PlayerX
GT0
			rts




Draw_MrCelery:
                ldx #0                 ; this counts our scanline number



Forehead:
	            sta WSYNC              ; wait till end of scanline
                lda #%01111100
	
                sta PF1
                lda #0
                sta PF2      
                sta PF0
				sleep 15
				sta RESM1	; reset missile1 position						
				
                SLEEP 13
				
	
				
				lda #0
				sta PF1
                inx
                cpx #10
                bne Forehead
Eyes:

			


				

				lda #2
				sta ENAM1  ;enable it
				
				
Eyes2:				
	            sta WSYNC              ; wait till end of scanline	
                lda #%01110100
                sta PF1
                lda #0
                sta PF2      
                sta PF0
                SLEEP 28		
				lda #0
				sta PF1	
                inx
                cpx #18
                bne Eyes2	
				
				lda #0
				sta ENAM1  ;enable it

Forehead2:
	            sta WSYNC              ; wait till end of scanline
                lda #%01111100
                sta PF1
                lda #0
                sta PF2      
                sta PF0
                SLEEP 28
				lda #0
				sta PF1
                inx
                cpx #22
                bne Forehead2



				rts

VegGfx
	.byte #%01101100
	.byte #%00101000
	.byte #%00111010
	.byte #%11111110
	.byte #%10010000
	.byte #%00111000
	.byte #%00111000
VEG_HEIGHT = * - VegGfx
	
IncinGfx
	.byte #%11111111
	.byte #%00011111
	.byte #%00011111
	.byte #%00011111
	.byte #%00011111
	.byte #%00011111
	.byte #%00011111
	.byte #%00011111
	.byte #%11111111
INCIN_HEIGHT = * - IncinGfx

            ORG $FFFA

InterruptVectors
            .word Reset          ; NMI
            .word Reset          ; RESET
            .word Reset          ; IRQ

      END
